<?php


namespace Schaffen\Core\Form\Managers;


use Freelabois\LaravelQuickstart\Extendables\ManipulationManager;
use Illuminate\Support\Facades\DB;

use Schaffen\Core\Form\Models\FormAssociation;
use Schaffen\Core\Form\Models\FormGrouping;

use Schaffen\Core\Form\Repositories\FormAssociationRepository;
use Schaffen\Core\Form\Repositories\FormGroupingRepository;
use Schaffen\Core\Form\Repositories\FormRepository;


class FormGroupingManager extends ManipulationManager
{
   public function __construct(FormGroupingRepository $repository)
   {
      parent::__construct($repository);
   }

   public function storeOrUpdate($values, int $id = null, $relations = [])
   {
      if(empty($id)){
         $values['foag_status'] = FormGrouping::STATUS_ACTIVE;
      }
      $form_grouping = null;
      DB::transaction(function () use ($values, $id, $relations, &$form_grouping){
         $form_grouping = parent::storeOrUpdate($values, $id, $relations);
         if(isset($values['forms']) && count($values['forms']) > 0){
            $form_grouping->association()->delete();
            $form_repository = app()->make(FormRepository::class);
            $form_association_repository = app()->make( FormAssociationRepository::class);
            foreach ($values['forms'] as $form_id){
               $form_db = $form_repository->find($form_id);
               $form_association_repository->firstOrNew(
                  [
                     "foa_formeavel_tipo" => FormAssociation::FORM_GROUPING,
                     "foa_formeavel_codigo" => $form_grouping->foag_codigo,
                     "foa_fk_form_codigo" => $form_id
                  ],[], [["name" => 'form', "model" => $form_db]]
               );
            }
            $form_grouping->load('forms');
         }
      });
      return $form_grouping;
   }
}
