<?php

namespace Schaffen\Core\Person\Models;

use Illuminate\Database\Eloquent\Model;
use Schaffen\Core\Employee\Models\Employee;
use Schaffen\Core\User\Models\User;

class Person extends Model
{
    protected $connection = 'dynamicdb';
    public $hidden = ["pes_imagem"];
    protected $table = "cadastro.pessoa";
    protected $primaryKey = "pes_codigo";
    const CREATED_AT = 'pes_date_insert';
    const UPDATED_AT = 'pes_date_update';
    protected $fillable = [
        "pes_codigo",
        "pes_nome",
        "pes_identificador",
        "pes_tipo",
        "pes_razao_social",
        "pes_user_insert",
        "pes_user_update",
        "pes_codigo_externo",
        "pes_inscricao_estadual",
        "pes_nome_reduzido",
        "pes_fk_fil_codigo",
        "pes_imagem",
        "pes_observacao",
        "pes_limite_credito",
        "pes_status",
        "pes_cad_pro",
        "pes_inscricao_municipal",
        "pes_dias_bloqueio_os",
        'pes_cad_incompleto'
    ];

    public function employee()
    {
        return $this->hasOne(Employee::class, 'fun_fk_pes_codigo');
    }

    public function users()
    {
        return $this->hasMany(User::class, 'usu_fk_pes_codigo');
    }

    public function address()
    {
        return $this->hasMany(Address::class, 'pee_fk_pes_codigo');
    }

    public function contact()
    {
        return $this->hasMany(Contact::class, 'peco_fk_pes_codigo');
    }

    public function default_address()
    {
        return $this->hasOne(Address::class, 'pee_fk_pes_codigo')->where('pee_padrao', 1)->withDefault(
            [
                'pee_logradouro' => 'SEM ENDEREÇO PADRÃO',
                'pee_numero' => '',
                'pee_bairro' => '',
                'pee_cidade' => '',
                "pee_latitude" => null,
                "pee_longitude" => null
            ]
        );
    }


}
