<?php


namespace Schaffen\Core\Person\Repositories;

use Freelabois\LaravelQuickstart\Extendables\Repository;
use Schaffen\Core\Person\Models\Person;

class PersonRepository extends Repository
{
    protected $model = Person::class;

    protected $searchableFields = [
        ["field" => 'pes_status']
    ];

    public function injectFiltersOnQuery()
    {
        $serial = null;
        $precisa_de_usuario = null;
        extract($this->filters);

        $this->query->when($serial, function ($query) use ($serial) {
            return $query->whereHas('employee.mobile', function ($query) use ($serial) {
                return $query->where('fum_serial', $serial)
                    ->whereNull('fum_bloqueado')
                    ->where('fum_libera_manutencao', 1);
            });
        });

        $this->query->when($precisa_de_usuario, function ($query) {
            return $query->whereHas('users');
        });
        parent::injectFiltersOnQuery();
    }
}
