<?php

namespace Schaffen\Core\User\Models;

use Illuminate\Foundation\Auth\User as Authenticable;
use Illuminate\Notifications\Notifiable;
use Laravel\Passport\HasApiTokens;
use Schaffen\Core\Person\Models\Person;
use League\OAuth2\Server\Exception\OAuthServerException;

class User extends Authenticable
{
    use HasApiTokens, Notifiable;
    protected $connection = 'dynamicdb';
    protected $table = "acesso.usuario";
    protected $primaryKey = "usu_codigo";
    protected $fillable = ["usu_nome", "usu_fk_pes_codigo", "usu_status", "usu_date_insert", "usu_user_insert",
        "usu_date_update", "usu_user_update", "usu_codigo", "usu_senha", "usu_fk_gru_codigo", "usu_descricao", "usu_email",
        "usu_foto", "usu_senha_liberacao", "usu_financeiro", "usu_fk_gru_codigo_finan", "usu_fk_usu_codigo_finan",
        "usu_tipo_autenticacao"];

    protected $hidden = ["usu_senha", "usu_senha_liberacao", "usu_foto"];


    public function findForPassport($username)
    {
        $user = $this->where('usu_nome', $username)->where('usu_status', 1)->first();
        if (!$user) {
            throw new OAuthServerException('Invalid username', 401, 'invalid_credentials', 401);
        }
        return $user;
    }

    public function validateForPassportPasswordGrant($password)
    {
        if ($this->usu_senha !== md5($password)) {
            throw new OAuthServerException('Password doesn\'t match', 401, 'invalid_credentials', 401);
        }
        return true;
    }

    public function person()
    {
        return $this->belongsTo(Person::class, 'usu_fk_pes_codigo');
    }
}
